<?php
/**
 * @file
 * Page Callback for tracking.
 */

/**
 * Callback function displaying the map.
 *
 * @param object $user
 *   The user object from this livetracking page.
 *
 * @todo CODE ! The JS msut use the template_preprocess function instead.
 * (Make the code waiting until the map is here somehow). 
 *
 * @see nodejs_livetracking.module
 * 
 * @see nodejs_livetracking_storage.module
 *
 * @see nodejs_checker.module 
 */
function nodejs_livetracking_track($user, $dimension) {
  // By default the tracker isn't conencted.
  $tracker = FALSE;

  // If $user has no uid... It's an annonymous page. Otherwise it's an user page.
  if (!isset($user->uid)) {
    // We subscribe to the correct channel by finding the right uuid : user-pass
    $uuids = db_query("SELECT uuid FROM {nodejs_livetracking_presence} WHERE uuid LIKE :user AND uid = 0",
      array(':user' => db_like($user) . '%' )
    )->fetchAll();

    // If many answers are found, there is a conflict. 
    if (count($uuids) > 1) {
      drupal_set_message(t('There is a conflict beetween multiple anonymous users using the same login and password !!'), 'warning');
    }

    if (isset($uuids[0]->uuid)) {
      // subscribe to this channel.
      dsm($uuids[0]->uuid);
      nodejs_send_content_channel_token('tracking_' . $uuids[0]->uuid, FALSE);
      // The tracker is connected.
      $tracker = TRUE;
    }
  }
  else {
    // On a user page I just have to find back the pass to subscribe.
    $pass = db_query("SELECT pass FROM {nodejs_livetracking_device} WHERE uid = :uid", array(':uid' => $user->uid))->fetchField();
    // Subscribe.
    nodejs_send_content_channel_token('tracking_' . $user->name . '-' . $pass, FALSE);

    // Is the tracking device currently connected ?
    $result = db_query("SELECT COUNT(*) FROM {nodejs_livetracking_presence} WHERE uid=:uid", array(':uid' => $user->uid))->FetchField();
    if ($result > 0) {
      $tracker = TRUE;
    }
  }
  
  // Is Nodejs server on ??
  $nodejs = nodejs_checker_check_server();
  drupal_add_js(array('nodejs_checker' => array('state' => $nodejs)), 'setting');


  if ($dimension == 2) {
    // Render the default map from openlayers.
    $map = openlayers_render_map('livetracking_map');
    // It is important that this js file come AFTER rendering the map.
    // @Todo Call this script from template function. Make it wait to the map.
    drupal_add_js(drupal_get_path('module', 'nodejs_livetracking') . '/js/nodejs_livetracking.js', array('type' => 'file'));
  }
  else {
    $map = '';
    // I request the openlayers style defined from nodejs_livetracking.module.
    // The idea behind this is to have the same style on 2D and 3D map.
    $style = openlayers_style_load('livetracking_style');
    $style->data['url'] = $GLOBALS['base_url'];
    drupal_add_js(array('nodejs_livetracking' => $style->data), 'setting');
  }

  $params = array(
    'map' => $map,
    'tracker' => $tracker,
    'dimension' => $dimension,
    'nodejs' => $nodejs,
  );
  return theme('nodejs_livetracking', $params);
}
