/**
 * @File
 *
 * Javascript handler for the livetracking presence block.
 *
 * IMPORTANT : Do not remove some attribute. JAVASCRIPT use it.
 *
 * Add connected user to the list / Remove disconnected user from the list.
 */

(function($) {
  var ndevice;

  Drupal.behaviors.nodejs_livetracking_presence_block = {
    'attach': function(context, setting) {
      if (context == document) {
        ndevice = Drupal.settings.nodejs_livetracking.ndevice;
        console.log(ndevice);
      }
    },

    'sortList' : function() {
      var mylist = $('#online_device_ul');
      var listitems = mylist.children('li').get();
      listitems.sort(function(a, b) {
        return $(a).text().toUpperCase().localeCompare($(b).text().toUpperCase());
      })
      $.each(listitems, function(idx, itm) {
        mylist.append(itm);
      });
    }
  };

  Drupal.Nodejs.callbacks.nodejs_livetracking_presence = {
    callback: function(message) {
      if (message.destinationChannel == "all_tracking") {
        if (message.messageType == 'device-auth') {
          $('#some_device_connected').removeClass('nodejs_livetracking_hidden');
          $('#no_device_connected').addClass('nodejs_livetracking_hidden');
          ndevice++;
          $(".ndevice").html(ndevice);
          $("#online_device_ul").append('<li id="tracking_' + message.uid + '"><a href="/user/' + message.uid + '/tracking">' + message.name + '</li>');
          Drupal.behaviors.nodejs_livetracking_presence_block.sortList();
        }
        else if (message.messageType == 'device-off') {
          ndevice--;
          $(".ndevice").html(ndevice);
          $("li#tracking_" + message.uid).remove();
          if (ndevice == 0) {
            $('#some_device_connected').addClass('nodejs_livetracking_hidden');
            $('#no_device_connected').removeClass('nodejs_livetracking_hidden');
          }
        }
      }
    },
  };
})(jQuery);
