<?php

/**
 * @file
 * nodejs_livetracking theme implementation to display a single livetracking on 
 * an openlayers map.
 *
 * IMPORTANT !!! Don't remove following id attibutes : "connection" / "lat" /
 * "lon" / "timestamp" / "vitesse" / "altitude" / "vario" / "precision".
 * JAVASCRIPT USE IT.
 *
 * @param object $map
 *    opnelayers map.
 *
 * @param int $tracker
 *    Is the device connected or not : 0 or 1
 *
 * @param bool $nodejs
 *    Is the nodejs server on or not.
 *
 * @see nodejs_livetracking.js
 *
 * @see nodejs_livetracking.css
 *
 * @todo Check how the JS and CSS that must always come along with this file 
 * can be automaticaly attached !   
 */
?>
<?php if (!$nodejs):?>
  <?php drupal_set_message(t('It seems the Nodejs server is down !'), 'warning'); ?>
<?php endif;?>
<div id="mapcontainer">
<?php if ($dimension == 2): ?>
  <?php print $map; ?>
<?php else: ?>
  <div id="map3d" style="height:100%; width:100%;"></div>
<?php endif; ?>
</div>

<div id="info">
  <div id="info-left" class="info-col">
    <div id="connection">
    <?php if ($tracker == 0): ?>
    <?php print "<div id='connected' class='hidden'>" . t('Tracking device connected') . "</div>"; ?>
    <?php print "<div id='disconnected'>" . t('Tracking device disconnected') . "</div>"; ?>
    <?php else: ?>
    <?php print "<div id='connected'>" . t('Tracking device connected') . "</div>"; ?>
    <?php print "<div id='disconnected' class='hidden'>" . t('Tracking device disconnected') . "</div>"; ?>
    <?php endif; ?>
    </div>
    <div id='follow'> <input type='checkbox' id='followme' name='followhim' value='follow' checked> <?php print t('Follow') ?> </div>
    <div id="info-position">
      <?php print t('Last known position :'); ?>
      <span id="lat"> <?php print t('Unknown'); ?> </span> , <span id="lon"> <?php print t('Unknown'); ?> </span>
      </div>
      <div id="info-timestamp">
      <?php print t('Position is : '); ?> <span id="tm"> <?php print t('Unknown'); ?> </span>
    </div>
  </div>
  <div id="info-right" class="info-col">
    <div id="info-speed">
      <?php print t('Speed'); ?> : <span id="sog"> <?php print t('Unknown'); ?> </span> <?php print t('km/h'); ?>
    </div>
    <div id="info-altitude">
      <?php print t('Altitude'); ?> : <span id="alt"> <?php print t('Unknown'); ?> </span> <?php print t('m'); ?>
    </div>
    <div id="info-vario">
      <?php print t('Variometer'); ?> : <span id="vario"> <?php print t('Unknown'); ?> </span> <?php print t('m/s'); ?>
    </div>
    <div id="info-precision">
        <?php print t('Position accuracy'); ?> : <span id="precision"> <?php print t('Unknown'); ?> </span> <?php print t('m'); ?>
    </div>
  </div>
</div>
<?php if ($dimension == 3): ?>
<div id="fullscreen" class="hidden">
  <input name="op" class="form-submit" id="fullscreen-submit" type="submit" value="<?php print t('Fullscreen mode') ?>"/>
</div>
<?php endif; ?>
